//+------------------------------------------------------------------+
//|  Klinger volume oscillator.mq4  - coded by Mladen                |
//|  added 4 ways colored histogram - brax64                         |
//+------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  DarkGray
#property indicator_color2  DarkOrange
#property indicator_color3  DeepSkyBlue
#property indicator_color4  Crimson
#property indicator_color5  DeepSkyBlue
#property indicator_color6  Crimson
#property indicator_width1  2
#property indicator_style3  2
#property indicator_style4  2
#property indicator_style5  2
#property indicator_style6  2 

//
//
//
//

extern int  LongEma             = 55;
extern int  ShortEma            = 34;
extern int  SignalEma           = 5;
extern bool UseRangeCalculation = true;
extern bool only_histo          = false;

double kvo[];
double signal[];
double kvoUxp[];
double kvoUxn[];
double kvoDxp[];
double kvoDxn[];

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   if (only_histo == false)
    {
     SetIndexBuffer(0,kvo);    SetIndexStyle(0,DRAW_LINE,0,2,DarkGray);         SetIndexLabel(0,"kvo");
     SetIndexBuffer(1,signal); SetIndexStyle(1,DRAW_LINE,0,0,DarkOrange);       SetIndexLabel(1,"signal");
     SetIndexBuffer(2,kvoUxp); SetIndexStyle(2,DRAW_HISTOGRAM,2,0,DeepSkyBlue); SetIndexLabel(2,"kvoUxp");
     SetIndexBuffer(3,kvoUxn); SetIndexStyle(3,DRAW_HISTOGRAM,2,0,Crimson);     SetIndexLabel(3,"kvoUxn");
     SetIndexBuffer(4,kvoDxp); SetIndexStyle(4,DRAW_HISTOGRAM,2,0,DeepSkyBlue); SetIndexLabel(4,"kvoDxp");
     SetIndexBuffer(5,kvoDxn); SetIndexStyle(5,DRAW_HISTOGRAM,2,0,Crimson);     SetIndexLabel(5,"kvoDxn");
    }
   if (only_histo == true)
    {
     SetIndexBuffer(0,kvo);    SetIndexStyle(0,DRAW_NONE,0,0,CLR_NONE);         SetIndexLabel(0,NULL);
     SetIndexBuffer(1,signal); SetIndexStyle(1,DRAW_NONE,0,0,CLR_NONE);         SetIndexLabel(1,NULL);
     SetIndexBuffer(2,kvoUxp); SetIndexStyle(2,DRAW_HISTOGRAM,0,3,DeepSkyBlue); SetIndexLabel(2,"kvoUxp");
     SetIndexBuffer(3,kvoUxn); SetIndexStyle(3,DRAW_HISTOGRAM,0,3,Brown);       SetIndexLabel(3,"kvoUxn");
     SetIndexBuffer(4,kvoDxp); SetIndexStyle(4,DRAW_HISTOGRAM,0,3,RoyalBlue);   SetIndexLabel(4,"kvoDxp");
     SetIndexBuffer(5,kvoDxn); SetIndexStyle(5,DRAW_HISTOGRAM,0,3,Red);         SetIndexLabel(5,"kvoDxn");
    }
      
   string add =""; 
       if (UseRangeCalculation) add = "using range";
   IndicatorShortName("Klinger volume "+add+" oscillator color histo ("+LongEma+","+ShortEma+","+SignalEma+") ");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double work[][6];
#define _price 0
#define _trend 1
#define _dm    2
#define _cm    3
#define _ema1  4
#define _ema2  5

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   double alpha1 = 2.0/(1.0+LongEma);
   double alpha2 = 2.0/(1.0+ShortEma);
   double alpha3 = 2.0/(1.0+SignalEma);
   
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_price] = (High[i]+Low[i]+Close[i])/3.0;
         work[r][_trend] = work[r-1][_trend];
         
            if (work[r][_price]>work[r-1][_price]) work[r][_trend] =  1;
            if (work[r][_price]<work[r-1][_price]) work[r][_trend] = -1;
         
            //
            //
            //
            //
            //
            
            double volume;
               if (UseRangeCalculation)
               {
                  work[r][_dm] = High[i]-Low[i];
                     if (work[r][_trend]==work[r-1][_trend])
                           work[r][_cm] = work[r-1][_cm]+work[r][_dm];
                     else  work[r][_cm] = work[r-1][_dm]+work[r][_dm];
                  volume = work[r][_trend]*Volume[i] * MathAbs(2.0*work[r][_dm]/work[r][_cm] - 1.0);
               }
               else volume = work[r][_trend]*Volume[i];

            //
            //
            //
            //
            //
            
                          work[r][_ema1] = work[r-1][_ema1]+alpha1*(volume-work[r-1][_ema1]);
                          work[r][_ema2] = work[r-1][_ema2]+alpha2*(volume-work[r-1][_ema2]);
                                  kvo[i] = work[r][_ema2]-work[r][_ema1];
                                                              
            if (SignalEma > 1) signal[i] = signal[i+1]+alpha3*(kvo[i]-signal[i+1]);
             {
                               kvoUxp[i] = EMPTY_VALUE;
                               kvoUxn[i] = EMPTY_VALUE;
                               kvoDxp[i] = EMPTY_VALUE;
                               kvoDxn[i] = EMPTY_VALUE;
                               
               if (kvo[i] > 0 && kvo[i] > signal[i]) kvoUxp[i] = kvo[i];
               if (kvo[i] > 0 && kvo[i] < signal[i]) kvoUxn[i] = kvo[i];
               if (kvo[i] < 0 && kvo[i] < signal[i]) kvoDxn[i] = kvo[i];
               if (kvo[i] < 0 && kvo[i] > signal[i]) kvoDxp[i] = kvo[i];
             }
            if  (SignalEma < 1)
             {
                               kvoUxp[i] = EMPTY_VALUE;
                               kvoUxn[i] = EMPTY_VALUE;
                               kvoDxp[i] = EMPTY_VALUE;
                               kvoDxn[i] = EMPTY_VALUE;
            
                if (kvo[i] > 0)                      kvoUxp[i] = kvo[i];
                if (kvo[i] < 0)                      kvoDxn[i] = kvo[i];
             }
      }
   return(0);
}

